/**
 * generated by Xtext
 */
package de.cau.cs.kieler.kiml.grana.text.ui.contentassist;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import de.cau.cs.kieler.core.kgraph.PersistentEntry;
import de.cau.cs.kieler.kiml.LayoutAlgorithmData;
import de.cau.cs.kieler.kiml.LayoutMetaDataService;
import de.cau.cs.kieler.kiml.LayoutOptionData;
import de.cau.cs.kieler.kiml.grana.AnalysisData;
import de.cau.cs.kieler.kiml.grana.AnalysisService;
import de.cau.cs.kieler.kiml.grana.text.services.GranaGrammarAccess;
import de.cau.cs.kieler.kiml.grana.text.ui.contentassist.AbstractGranaProposalProvider;
import de.cau.cs.kieler.kiml.options.LayoutOptions;
import de.cau.cs.kieler.kiml.ui.LayoutOptionLabelProvider;
import java.util.Collection;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.viewers.StyledString;
import org.eclipse.swt.graphics.Image;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.conversion.IValueConverterService;
import org.eclipse.xtext.ui.editor.contentassist.ConfigurableCompletionProposal;
import org.eclipse.xtext.ui.editor.contentassist.ContentAssistContext;
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;
import org.eclipse.xtext.ui.editor.contentassist.IContentProposalPriorities;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.ExclusiveRange;
import org.eclipse.xtext.xbase.lib.StringExtensions;

/**
 * see http://www.eclipse.org/Xtext/documentation.html#contentAssist on how to customize content assistant
 * 
 * @author uru
 */
@SuppressWarnings("all")
public class GranaProposalProvider extends AbstractGranaProposalProvider {
  @Inject
  private GranaGrammarAccess grammarAccess;
  
  /**
   * Proposals for graph analyses.
   */
  public void completeAnalysis_Name(final EObject model, final Assignment assignment, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
    super.completeAnalysis_Name(model, assignment, context, acceptor);
    AnalysisService _instance = AnalysisService.getInstance();
    Collection<AnalysisData> _analyses = _instance.getAnalyses();
    for (final AnalysisData a : _analyses) {
      String _id = a.getId();
      String _prefix = context.getPrefix();
      boolean _isValidProposal = this.isValidProposal(_id, _prefix, context);
      if (_isValidProposal) {
        String _name = a.getName();
        final StyledString displayString = new StyledString(_name);
        String _id_1 = a.getId();
        IContentProposalPriorities _priorityHelper = this.getPriorityHelper();
        int _defaultPriority = _priorityHelper.getDefaultPriority();
        int _plus = (_defaultPriority + 1);
        ConfigurableCompletionProposal _doCreateProposal = this.doCreateProposal(_id_1, displayString, null, _plus, context);
        acceptor.accept(_doCreateProposal);
      }
    }
  }
  
  /**
   * Proposals for layout option keys.
   */
  public void completePersistentEntry_Key(final EObject model, final Assignment assignment, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
    LayoutMetaDataService _instance = LayoutMetaDataService.getInstance();
    Collection<LayoutOptionData> _optionData = _instance.getOptionData();
    for (final LayoutOptionData optionData : _optionData) {
      {
        String _string = optionData.toString();
        StyledString.Styler _xifexpression = null;
        boolean _isAdvanced = optionData.isAdvanced();
        if (_isAdvanced) {
          _xifexpression = StyledString.COUNTER_STYLER;
        } else {
          _xifexpression = null;
        }
        final StyledString displayString = new StyledString(_string, _xifexpression);
        String _id = optionData.getId();
        String _plus = (" (" + _id);
        String _plus_1 = (_plus + ")");
        displayString.append(_plus_1, StyledString.QUALIFIER_STYLER);
        IValueConverterService _valueConverter = this.getValueConverter();
        String _id_1 = optionData.getId();
        ParserRule _qualifiedIDRule = this.grammarAccess.getQualifiedIDRule();
        String _name = _qualifiedIDRule.getName();
        final String proposal = _valueConverter.toString(_id_1, _name);
        final LayoutOptionLabelProvider labelProvider = new LayoutOptionLabelProvider(optionData);
        Object _default = optionData.getDefault();
        final Image image = labelProvider.getImage(_default);
        String _id_2 = optionData.getId();
        this.handleKeyProposal(context, acceptor, _id_2, proposal, displayString, image);
      }
    }
  }
  
  /**
   * Copied from {@link KGraphProposalProvider}.
   */
  private void handleKeyProposal(final ContentAssistContext context, final ICompletionProposalAcceptor acceptor, final String id, final String proposal, final StyledString displayString, final Image image) {
    String _prefix = context.getPrefix();
    boolean _isValidProposal = this.isValidProposal(proposal, _prefix, context);
    if (_isValidProposal) {
      IContentProposalPriorities _priorityHelper = this.getPriorityHelper();
      int _defaultPriority = _priorityHelper.getDefaultPriority();
      ConfigurableCompletionProposal _doCreateProposal = this.doCreateProposal(proposal, displayString, image, _defaultPriority, context);
      acceptor.accept(_doCreateProposal);
    } else {
      final int lastDotIndex = id.lastIndexOf(".");
      if ((lastDotIndex >= 0)) {
        String _substring = id.substring(0, (lastDotIndex + 1));
        final StringBuilder prefix = new StringBuilder(_substring);
        String _prefix_1 = context.getPrefix();
        prefix.append(_prefix_1);
        int i = 0;
        while (((i < proposal.length()) && (i < prefix.length()))) {
          {
            char _charAt = proposal.charAt(i);
            char _charAt_1 = prefix.charAt(i);
            boolean _notEquals = (_charAt != _charAt_1);
            if (_notEquals) {
              char _charAt_2 = proposal.charAt(i);
              boolean _equals = Objects.equal(Character.valueOf(_charAt_2), "^");
              if (_equals) {
                prefix.insert(i, "^");
              } else {
                int _length = proposal.length();
                i = _length;
              }
            }
            i = (i + 1);
          }
        }
        String _string = prefix.toString();
        boolean _isValidProposal_1 = this.isValidProposal(proposal, _string, context);
        if (_isValidProposal_1) {
          IContentProposalPriorities _priorityHelper_1 = this.getPriorityHelper();
          int _defaultPriority_1 = _priorityHelper_1.getDefaultPriority();
          ConfigurableCompletionProposal _doCreateProposal_1 = this.doCreateProposal(proposal, displayString, image, _defaultPriority_1, context);
          acceptor.accept(_doCreateProposal_1);
        }
      }
    }
  }
  
  public void completePersistentEntry_Value(final EObject model, final Assignment assignment, final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
    super.completePersistentEntry_Value(model, assignment, context, acceptor);
    this.valueProposal(context, acceptor);
  }
  
  /**
   * Copied from {@link KGraphProposalProvider}.
   * 
   * Computes the annotation value proposals based on a foregoing layout parameter.
   * 
   * @param context Xtext API
   * @param acceptor Xtext API
   * 
   * @author sgu, chsch
   */
  private void valueProposal(final ContentAssistContext context, final ICompletionProposalAcceptor acceptor) {
    EObject _currentModel = context.getCurrentModel();
    if ((_currentModel instanceof PersistentEntry)) {
      EObject _currentModel_1 = context.getCurrentModel();
      final String annotationName = ((PersistentEntry) _currentModel_1).getKey();
      boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(annotationName);
      boolean _not = (!_isNullOrEmpty);
      if (_not) {
        final LayoutMetaDataService layoutServices = LayoutMetaDataService.getInstance();
        LayoutOptionData optionData = layoutServices.getOptionData(annotationName);
        boolean _equals = Objects.equal(optionData, null);
        if (_equals) {
          LayoutOptionData _optionData = layoutServices.getOptionData(("de.cau.cs.kieler." + annotationName));
          optionData = _optionData;
        }
        LayoutOptionData.Type _xifexpression = null;
        boolean _notEquals = (!Objects.equal(optionData, null));
        if (_notEquals) {
          _xifexpression = optionData.getType();
        } else {
          _xifexpression = LayoutOptionData.Type.UNDEFINED;
        }
        final LayoutOptionData.Type theType = _xifexpression;
        String proposal = null;
        boolean _matched = false;
        if (!_matched) {
          if (Objects.equal(theType, LayoutOptionData.Type.BOOLEAN)) {
            _matched=true;
          }
          if (!_matched) {
            if (Objects.equal(theType, LayoutOptionData.Type.ENUM)) {
              _matched=true;
            }
          }
          if (!_matched) {
            if (Objects.equal(theType, LayoutOptionData.Type.ENUMSET)) {
              _matched=true;
            }
          }
          if (_matched) {
            String[] _choices = optionData.getChoices();
            int _length = _choices.length;
            ExclusiveRange _doubleDotLessThan = new ExclusiveRange(0, _length, true);
            for (final Integer j : _doubleDotLessThan) {
              {
                String[] _choices_1 = optionData.getChoices();
                String _get = _choices_1[(j).intValue()];
                proposal = _get;
                ICompletionProposal _createCompletionProposal = this.createCompletionProposal(proposal, context);
                acceptor.accept(_createCompletionProposal);
              }
            }
          }
        }
        if (!_matched) {
          boolean _and = false;
          boolean _equals_1 = Objects.equal(theType, LayoutOptionData.Type.STRING);
          if (!_equals_1) {
            _and = false;
          } else {
            String _id = LayoutOptions.ALGORITHM.getId();
            boolean _equals_2 = annotationName.equals(_id);
            _and = _equals_2;
          }
          if (_and) {
            _matched=true;
            String displayString = null;
            Collection<LayoutAlgorithmData> _algorithmData = layoutServices.getAlgorithmData();
            for (final LayoutAlgorithmData data : _algorithmData) {
              {
                String _id_1 = data.getId();
                String _plus = ("\"" + _id_1);
                String _plus_1 = (_plus + "\"");
                proposal = _plus_1;
                String _name = data.getName();
                displayString = _name;
                ICompletionProposal _createCompletionProposal = this.createCompletionProposal(proposal, displayString, null, context);
                acceptor.accept(_createCompletionProposal);
              }
            }
          }
        }
        if (!_matched) {
          if (Objects.equal(theType, LayoutOptionData.Type.STRING)) {
            _matched=true;
          }
          if (!_matched) {
            if (Objects.equal(theType, LayoutOptionData.Type.FLOAT)) {
              _matched=true;
            }
          }
          if (!_matched) {
            if (Objects.equal(theType, LayoutOptionData.Type.INT)) {
              _matched=true;
            }
          }
          if (!_matched) {
            if (Objects.equal(theType, LayoutOptionData.Type.OBJECT)) {
              _matched=true;
            }
          }
          if (_matched) {
            if (theType != null) {
              switch (theType) {
                case STRING:
                  proposal = "\"\"";
                  break;
                case FLOAT:
                  proposal = "0.0";
                  break;
                case INT:
                  proposal = "0";
                  break;
                case OBJECT:
                  try {
                    Class<?> _optionClass = optionData.getOptionClass();
                    Object _newInstance = _optionClass.newInstance();
                    String _string = _newInstance.toString();
                    String _plus = ("\"" + _string);
                    String _plus_1 = (_plus + "\"");
                    proposal = _plus_1;
                  } catch (final Throwable _t) {
                    if (_t instanceof InstantiationException) {
                      final InstantiationException e = (InstantiationException)_t;
                      proposal = "\"\"";
                    } else if (_t instanceof IllegalAccessException) {
                      final IllegalAccessException e_1 = (IllegalAccessException)_t;
                      proposal = "\"\"";
                    } else {
                      throw Exceptions.sneakyThrow(_t);
                    }
                  }
                  break;
                default:
                  proposal = "";
                  break;
              }
            } else {
              proposal = "";
            }
            LayoutOptionData.Type _type = optionData.getType();
            String _string_1 = _type.toString();
            ICompletionProposal _createCompletionProposal = this.createCompletionProposal(proposal, _string_1, null, context);
            acceptor.accept(_createCompletionProposal);
          }
        }
      }
    }
  }
}
