package de.cau.cs.kieler.klighd.examples.ecore;

import com.google.common.collect.Iterators;
import com.google.common.collect.UnmodifiableIterator;
import de.cau.cs.kieler.core.kgraph.KNode;
import de.cau.cs.kieler.core.properties.IProperty;
import de.cau.cs.kieler.core.util.Pair;
import de.cau.cs.kieler.klighd.SynthesisOption;
import de.cau.cs.kieler.klighd.ViewContext;
import de.cau.cs.kieler.klighd.examples.ecore.EModelElementCollection;
import de.cau.cs.kieler.klighd.examples.ecore.EcoreDiagramSynthesis;
import de.cau.cs.kieler.klighd.syntheses.AbstractDiagramSynthesis;
import java.util.List;
import javax.inject.Inject;
import org.eclipse.emf.ecore.EPackage;

@SuppressWarnings("all")
public class EcoreFileDiagramSynthesis extends AbstractDiagramSynthesis<EPackage> {
  @Inject
  private EcoreDiagramSynthesis delegate;
  
  public KNode transform(final EPackage model) {
    UnmodifiableIterator<EPackage> _singletonIterator = Iterators.<EPackage>singletonIterator(model);
    final EModelElementCollection col = EModelElementCollection.of(_singletonIterator);
    ViewContext _usedContext = this.getUsedContext();
    return this.delegate.transform(col, _usedContext);
  }
  
  public List<SynthesisOption> getDisplayedSynthesisOptions() {
    return this.delegate.getDisplayedSynthesisOptions();
  }
  
  public List<Pair<IProperty<?>, List<?>>> getDisplayedLayoutOptions() {
    return this.delegate.getDisplayedLayoutOptions();
  }
}
